    001/* ========================================================================
    002 * JCommon : a free general purpose class library for the Java(tm) platform
    003 * ========================================================================
    004 *
    005 * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jcommon/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025 * in the United States and other countries.]
    026 *
    027 * -------------------
    028 * G2TextMeasurer.java
    029 * -------------------
    030 * (C) Copyright 2004, 2005, by Object Refinery Limited and Contributors.
    031 *
    032 * Original Author:  David Gilbert (for Object Refinery Limited);
    033 * Contributor(s):   -;
    034 *
    035 * $Id: G2TextMeasurer.java,v 1.4 2005/10/18 13:17:16 mungady Exp $
    036 *
    037 * Changes
    038 * -------
    039 * 07-Jan-2004 : Version 1 (DG);
    040 *
    041 */
    042
    043package org.jfree.text;
    044
    045import java.awt.FontMetrics;
    046import java.awt.Graphics2D;
    047import java.awt.geom.Rectangle2D;
    048
    049/**
    050 * A {@link TextMeasurer} based on a {@link Graphics2D}.
    051 *
    052 * @author David Gilbert
    053 */
    054public class G2TextMeasurer implements TextMeasurer {
    055
    056    /** The graphics device. */
    057    private Graphics2D g2;
    058
    059    /**
    060     * Creates a new text measurer.
    061     *
    062     * @param g2  the graphics device.
    063     */
    064    public G2TextMeasurer(final Graphics2D g2) {
    065        this.g2 = g2;
    066    }
    067
    068    /**
    069     * Returns the string width.
    070     *
    071     * @param text  the text.
    072     * @param start  the index of the first character to measure.
    073     * @param end  the index of the last character to measure.
    074     *
    075     * @return The string width.
    076     */
    077    public float getStringWidth(final String text,
    078                                final int start, final int end) {
    079        final FontMetrics fm = this.g2.getFontMetrics();
    080        final Rectangle2D bounds = TextUtilities.getTextBounds(
    081            text.substring(start, end), this.g2, fm
    082        );
    083        final float result = (float) bounds.getWidth();
    084        return result;
    085    }
    086
    087}
    088